# /etc/profile.d/sudo2uls_aliases.sh
#
# Aliaseintraege fuer sudo2uls anlegen
# Es werden Aliaseintraege in der Form
#
# alias <user>='sudo -H -u <user> /usr/bin/sudo2uls'
#   oder bei X11
# alias <user>='/usr/bin/sudo2ulsx <user>'
#
# Konfiuration ueber /etc/uls/sud2uls_user.conf
#
#
for A in `awk '$1 !~ "#" && $1 != "" {print $1}' /etc/uls/sudo2uls_user.conf`
 do
  U=`awk '$1 == "'$A'" {print $2}' /etc/uls/sudo2uls_user.conf`
  if [ "$A" != "-" ]
   then
    U=${U:-$A}
    if [ -z "$DISPLAY" ]
     then
      alias $A="sudo -H -u $U /usr/bin/sudo2uls"
    else
      alias $A="/usr/bin/sudo2ulsx $U"
    fi
  fi
done


# top und watch verhindern, wenn in Script2uls

if [ "${SUDO_COMMAND#/usr/bin/sudo2uls}" != "$SUDO_COMMAND" ]
 then
  alias top='top -n 100'
  alias watch="echo \"Please don't use watch in sudo2uls.\""
fi
