BEGIN { boundary = "^%%%$"
        dnr = 1
      }
/boundary=/ { gsub("^.*boundary=", "", $0)
              if( $0 ~ "^\".*\"$" )
	        gsub("\"", "", $0)
              boundary = "--" $0
            }

$0 == boundary {
  chs = ""
  while( getline > 0 )
  { while( $0 != "" )
    { if( $1 == "Content-Type" )
      { ct = $2
        if( $0 ~ /charset=utf-8/ )
          chs = "-c utf8"
      }
      else if( $1 == "Content-Transfer-Encoding" )
        cte = $2
      else if( $1 == "Content-Disposition" )
        cd = $2
      else if( $0 ~ " *filename=" )
      { gsub(" *filename=", "", $0)
        if( $0 ~ "^\".*\"$" )
          gsub("\"", "", $0)
        gsub(".*/", "", $0)
        filename = $0
      }
      getline
    }
    awkb64 = 0
    awkqp = 0
    if( cte == "base64" )
      awkb64 = 1
    else if( cte == "quoted-printable" )
      awkqp = 1
    if( filename == "" )
    { if( ct ~ "^text" )
      { if( TXTUNIT == "" )
          pcmd = "send_stdin_file "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Body "DT" body.txt"
        else
          pcmd = "send_file2uls "chs" "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Body "DT" \""TXTUNIT"\""
      }
      else
      { gsub("/.*", "", ct)
        pcmd = "send_stdin_file "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Attachment "DT" body."ct
      }
    }
    else
      pcmd = "send_stdin_file "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Attachment "DT" \"" filename "\""
    if( awkb64 )
    { B64 = "BCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
      while( getline > 0 )
      { if( $0 == "" )
        { getline
          if( $0 ==  boundary || $0 == boundary "--" )
            break
        }
        s = $0
        while( length(s) >= 4 )
        { c1 = index(B64,substr(s,1,1))
          c2 = index(B64,substr(s,2,1))
          c3 = index(B64,l3=substr(s,3,1))
          c4 = index(B64,l4=substr(s,4,1))
          s = substr(s,5)
          if( l4 != "=" )
            printf("%c%c%c",and(255,lshift(c1,2))+rshift(c2,4),and(255,lshift(c2,4))+rshift(c3,2),and(255,lshift(c3,6))+c4) | pcmd
          else if( l3 != "=" )
            printf("%c%c",and(255,lshift(c1,2))+rshift(c2,4),and(255,lshift(c2,4))+rshift(c3,2)) | pcmd
          else
            printf("%c",and(255,lshift(c1,2))+rshift(c2,4)) | pcmd
        }
      }
    }
    else if( awkqp )
    { HEX = "123456789ABCDEF"
      ll = 0
      while( getline > 0 )
      { if( ll )
        { if( $0 ==  boundary || $0 == boundary "--" )
            break
          else
            print "" | pcmd
        }
        if( ll = ($0 == "") )
          continue
        o = ""
        l = $0
        while( i = index(l, "=") )
        { if( i == length(l) )
          { o = o substr(l, 1, i-1)
            nlf = 0
            l = ""
          }
          else
          { o = o substr(l, 1, i-1) sprintf("%c", index(HEX,substr(l,i+1,1))*16+index(HEX,substr(l,i+2,1)))
            l = substr(l, i+3)
          }
        }
        printf("%s%s%s", o, l, nlf ? "\n": "") | pcmd
      }
    }
    else
    { ll = 0
      while( getline > 0 )
      { if( ll )
        { if( $0 ==  boundary || $0 == boundary "--" )
            break
          else
            print "" | pcmd
        }
        if( ll = ($0 == "") )
          continue
        print $0 | pcmd
      }
    }
    close(pcmd)
    filename = ct = cte = cd = ""
    if( $0 == boundary "--" )
      exit
  }
}
