BEGIN { HEX = "123456789ABCDEF"
        B64 = "BCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
      }

function b64(s)
{ r = ""
  while( length(s) >= 4 )
  { c1 = index(B64,substr(s,1,1))
    c2 = index(B64,substr(s,2,1))
    c3 = index(B64,l3=substr(s,3,1))
    c4 = index(B64,l4=substr(s,4,1))
    s = substr(s,5)
    if( l4 != "=" )
      r = r sprintf("%c%c%c",and(255,lshift(c1,2))+rshift(c2,4),and(255,lshift(c2,4))+rshift(c3,2),and(255,lshift(c3,6))+c4)
    else if( l3 != "=" )
      r = r sprintf("%c%c",and(255,lshift(c1,2))+rshift(c2,4),and(255,lshift(c2,4))+rshift(c3,2))
    else
      r = r sprintf("%c",and(255,lshift(c1,2))+rshift(c2,4))
  }
  return r
}

function qp(s)
{ r = ""
  while( i = index(s, "=") )
  { r = r substr(s, 1, i-1) sprintf("%c", index(HEX,substr(s,i+1,1))*16+index(HEX,substr(s,i+2,1)))
    s = substr(s, i+3)
  }
  return r s
}

/^[ \t]/  { if( z ~ "?=$" )
              z = z substr($0, 2)
            else if( z )
              z = z $0
          }
!/^[ \t]/ { if(z)
            { o = ""
              while( i = index(z, "=?") )
              { o = o substr(z, 1, i-1)
                z = substr(z, i+2)
                i = index(z, "?")
                c = substr(z, 1, i-1)
                e = substr(z, i+1, 1)
                d = substr(z, i+3)
                j = index(d, "?=")
                z = substr(d, j+2)
                d = substr(d, 1, j-1)
                if( d != "" )
                { gsub("_", " ", d)
                  if( c == "us-ascii" )
                  { if( e == "Q" )
                      o = o qp(d)
                    else if( e == "B" )
                      o = o b64(d)
                    else
                      o = o d
                  }
                  if( c == "iso-8859-1" )
                  { if( e == "Q" )
                    { cmd = "recode iso-8859-1/QP..UTF-8"
                      print d |& cmd
                      close(cmd, "to")
                      cmd |& getline u
                      o = o u
                      close(cmd, "from")
                    }
                    else if( e == "B" )
                    { cmd = "recode iso-8859-1/b64..UTF-8"
                      print d |& cmd
                      close(cmd, "to")
                      cmd |& getline u
                      o = o u
                      close(cmd, "from")
                    }
                    else
                      o = o d
                  }
                  else if( c == "utf-8" )
                  { if( e == "Q" )
                      o = o qp(d)
                    else if( e == "B" )
                      o = o b64(d)
                    else
                      o = o d
                  }
                }
              }
              print o z
              exit 0
            }
          }
/^Subject: / { z = substr($0,10)
             }
